git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Felipe Contreras <felipe.contreras@gmail.com>
To: git@vger.kernel.org
Cc: Junio C Hamano <gitster@pobox.com>, Jeff King <peff@peff.net>,
	Felipe Contreras <felipe.contreras@gmail.com>
Subject: [PATCH v2 43/48] remote-hg: add check_push() helper
Date: Fri, 24 May 2013 21:29:59 -0500	[thread overview]
Message-ID: <1369449004-17981-44-git-send-email-felipe.contreras@gmail.com> (raw)
In-Reply-To: <1369449004-17981-1-git-send-email-felipe.contreras@gmail.com>

Signed-off-by: Felipe Contreras <felipe.contreras@gmail.com>
---
 contrib/remote-helpers/test-hg.sh | 66 +++++++++++++++++++++++++++++----------
 1 file changed, 49 insertions(+), 17 deletions(-)

diff --git a/contrib/remote-helpers/test-hg.sh b/contrib/remote-helpers/test-hg.sh
index f594584..aeab48a 100755
--- a/contrib/remote-helpers/test-hg.sh
+++ b/contrib/remote-helpers/test-hg.sh
@@ -48,6 +48,38 @@ check_bookmark () {
 	fi
 }
 
+check_push () {
+	local expected_ret=$1 ret=0 ref_ret=0 IFS=':'
+
+	shift
+	git push origin "$@" 2> error
+	ret=$?
+	cat error
+
+	while read branch kind
+	do
+		case "$kind" in
+		'new')
+			grep "^ \* \[new branch\] *${branch} -> ${branch}$" error || ref_ret=1
+			;;
+		'non-fast-forward')
+			grep "^ ! \[rejected\] *${branch} -> ${branch} (non-fast-forward)$" error || ref_ret=1
+			;;
+		'')
+			grep "^   [a-f0-9]*\.\.[a-f0-9]* *${branch} -> ${branch}$" error || ref_ret=1
+			;;
+		esac
+		let 'ref_ret' && echo "match for '$branch' failed" && break
+	done
+
+	if let 'expected_ret != ret || ref_ret'
+	then
+		return 1
+	fi
+
+	return 0
+}
+
 setup () {
 	(
 	echo "[ui]"
@@ -344,8 +376,9 @@ test_expect_success 'remote push diverged' '
 	cd gitrepo &&
 	echo diverge > content &&
 	git commit -a -m diverged &&
-	test_expect_code 1 git push 2> error &&
-	grep "^ ! \[rejected\] *master -> master (non-fast-forward)$" error
+	check_push 1 <<-EOF
+	master:non-fast-forward
+	EOF
 	) &&
 
 	check_branch hgrepo default bump
@@ -373,8 +406,9 @@ test_expect_success 'remote update bookmark diverge' '
 	git checkout --quiet diverge &&
 	echo diverge > content &&
 	git commit -a -m diverge &&
-	test_expect_code 1 git push 2> error &&
-	grep "^ ! \[rejected\] *diverge -> diverge (non-fast-forward)$" error
+	check_push 1 <<-EOF
+	diverge:non-fast-forward
+	EOF
 	) &&
 
 	check_bookmark hgrepo diverge "bump bookmark"
@@ -468,19 +502,17 @@ test_expect_success 'remote big push' '
 
 	(
 	cd gitrepo &&
-	test_expect_code 1 git push origin master \
-		good_bmark bad_bmark1 bad_bmark2 new_bmark \
-		branches/good_branch branches/bad_branch \
-		branches/new_branch 2> error &&
-
-	grep "^   [a-f0-9]*\.\.[a-f0-9]* *master -> master$" error &&
-	grep "^   [a-f0-9]*\.\.[a-f0-9]* *good_bmark -> good_bmark$" error &&
-	grep "^ \* \[new branch\] *new_bmark -> new_bmark$" error &&
-	grep "^ ! \[rejected\] *bad_bmark2 -> bad_bmark2 (non-fast-forward)$" error &&
-	grep "^ ! \[rejected\] *bad_bmark1 -> bad_bmark1 (non-fast-forward)$" error &&
-	grep "^   [a-f0-9]*\.\.[a-f0-9]* *branches/good_branch -> branches/good_branch$" error &&
-	grep "^ ! \[rejected\] *branches/bad_branch -> branches/bad_branch (non-fast-forward)$" error &&
-	grep "^ \* \[new branch\] *branches/new_branch -> branches/new_branch$" error
+
+	check_push 1 --all <<-EOF
+	master
+	good_bmark
+	branches/good_branch
+	new_bmark:new
+	branches/new_branch:new
+	bad_bmark1:non-fast-forward
+	bad_bmark2:non-fast-forward
+	branches/bad_branch:non-fast-forward
+	EOF
 	) &&
 
 	check_branch hgrepo default one &&
-- 
1.8.3.rc3.312.g47657de

  parent reply	other threads:[~2013-05-25  2:34 UTC|newest]

Thread overview: 51+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2013-05-25  2:29 [PATCH v2 00/48] remote-hg: fixes for next Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 01/48] remote-hg: test: be a little more quiet Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 02/48] remote-hg: trivial reorganization Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 03/48] remote-helpers: test: cleanup white-spaces Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 04/48] remote-helpers: test: cleanup style Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 05/48] remote-helpers: tests: general improvements Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 06/48] remote-helpers: test: simplify remote URLs Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 07/48] remote-hg: test: simplify previous branch checkout Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 08/48] remote-hg: load all extensions Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 09/48] remote-hg: use a shared repository store Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 10/48] remote-hg: shuffle some code Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 11/48] remote-hg: improve node traversing Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 12/48] remote-hg: add version checks to the marks Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 13/48] remote-hg: switch from revisions to SHA-1 noteids Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 14/48] remote-hg: upgrade version 1 marks Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 15/48] remote-hg: ensure remote rebasing works Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 16/48] remote-hg: trivial cleanups Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 17/48] remote-hg: improve progress calculation Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 18/48] remote-hg: always point HEAD to master Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 19/48] remote-hg: add tests for 'master' bookmark Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 20/48] remote-bzr: simplify test checks Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 21/48] remote-hg: add check_bookmark() test helper Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 22/48] remote-hg: update bookmarks when using a remote Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 23/48] remote-hg: add remote tests Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 24/48] remote-hg: add test to push new bookmark Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 25/48] remote-hg: add test for diverged push Felipe Contreras
2013-05-25  6:28   ` Eric Sunshine
2013-05-25  2:29 ` [PATCH v2 26/48] remote-hg: add test for bookmark diverge Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 27/48] remote-hg: add test for new bookmark special Felipe Contreras
2013-05-25  6:27   ` Eric Sunshine
2013-05-25  2:29 ` [PATCH v2 28/48] remote-hg: add test for big push Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 29/48] remote-hg: add test for failed double push Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 30/48] remote-hg: reorganize bookmark handling Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 31/48] remote-hg: force remote bookmark push selectively Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 32/48] remote-hg: only update necessary revisions Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 33/48] remote-hg: implement custom push() Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 34/48] remote-hg: implement custom checkheads() Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 35/48] remote-hg: pass around revision refs Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 36/48] remote-hg: check diverged bookmarks Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 37/48] remote-hg: simplify branch_tip() Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 38/48] remote-hg: improve branch listing Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 39/48] remote-hg: use remote 'default' not local one Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 40/48] remote-hg: improve lightweight tag author Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 41/48] remote-hg: remove files before modifications Felipe Contreras
2013-05-25  2:29 ` [PATCH v2 42/48] remote-hg: add setup_big_push() helper Felipe Contreras
2013-05-25  2:29 ` Felipe Contreras [this message]
2013-05-25  2:30 ` [PATCH v2 44/48] remote-helpers: improve marks usage Felipe Contreras
2013-05-25  2:30 ` [PATCH v2 45/48] remote-hg: trivial cleanup Felipe Contreras
2013-05-25  2:30 ` [PATCH v2 46/48] remote-hg: check if a fetch is needed Felipe Contreras
2013-05-25  2:30 ` [PATCH v2 47/48] remote-hg: add support for --dry-run Felipe Contreras
2013-05-25  2:30 ` [PATCH v2 48/48] remote-hg: add support for --force Felipe Contreras

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1369449004-17981-44-git-send-email-felipe.contreras@gmail.com \
    --to=felipe.contreras@gmail.com \
    --cc=git@vger.kernel.org \
    --cc=gitster@pobox.com \
    --cc=peff@peff.net \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).